package info.jbcs.minecraft.safe;

import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.texture.TextureManager;
import net.minecraft.client.renderer.tileentity.TileEntityRenderer;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ResourceLocation;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class TileEntitySafeRenderer extends TileEntitySpecialRenderer {
	private static final ResourceLocation	RES_NORMAL_SINGLE	= new ResourceLocation("safe:textures/entity/safe/metal.png");
	public static ModelSafe					model				= new ModelSafe();

	public void bind(ResourceLocation par1ResourceLocation) {
		TextureManager texturemanager = TileEntityRenderer.instance.renderEngine;

		if (texturemanager != null) {
			texturemanager.bindTexture(par1ResourceLocation);
		}
	}

	/**
	 * Renders the TileEntity for the chest at a position.
	 */
	public void renderTileEntityChestAt(TileEntitySafe safe, double x, double y, double z, float frame) {
		int meta;

		bind(RES_NORMAL_SINGLE);

		if (!safe.hasWorldObj()) {
			meta = 0;
		} else {
			Block block = safe.getBlockType();
			meta = safe.getBlockMetadata();
		}

		GL11.glPushMatrix();
		GL11.glEnable(GL12.GL_RESCALE_NORMAL);
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		GL11.glTranslatef((float) x, (float) y + 1.0F, (float) z + 1.0F);
		GL11.glScalef(1.0F, -1.0F, -1.0F);
		GL11.glTranslatef(0.5F, 0.5F, 0.5F);
		short short1 = 0;

		if (meta == 2) {
			short1 = 180;
		}

		if (meta == 3) {
			short1 = 0;
		}

		if (meta == 4) {
			short1 = 90;
		}

		if (meta == 5) {
			short1 = -90;
		}

		GL11.glRotatef(short1, 0.0F, 1.0F, 0.0F);
		GL11.glRotatef(-90, 0.0f, 0.0f, 1.0f);
		GL11.glRotatef( 90, 1.0f, 0.0f, 0.0f);
		GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
		float f1 = safe.prevLidAngle + (safe.lidAngle - safe.prevLidAngle) * frame;
		float f2;

		f1 = 1.0F - f1;
		f1 = 1.0F - f1 * f1 * f1;
		model.chestLid.rotateAngleX = -(f1 * (float) Math.PI / 2.0F);
		model.renderAll();
		GL11.glDisable(GL12.GL_RESCALE_NORMAL);
		GL11.glPopMatrix();
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);

		
		if(ProxyClient.hoveringBlock && ProxyClient.hoverX==safe.xCoord && ProxyClient.hoverY==safe.yCoord && ProxyClient.hoverZ==safe.zCoord){
			renderLivingLabel(safe.ownerName,x,y+1.0f,z);
		}
	}


    /**
     * Draws the debug or playername text above a living
     */
    protected void renderLivingLabel(String par2Str, double x, double y, double z){
//        double d3 = par1EntityLivingBase.getDistanceSqToEntity(this.renderManager.livingPlayer);

    	RenderManager manager=RenderManager.instance;
    	
    	
//        if (d3 <= par9 * par9)
//        {
            FontRenderer fontrenderer = Minecraft.getMinecraft().fontRenderer;
            float f = 1.6F;
            float f1 = 0.016666668F * f;
            GL11.glPushMatrix();
            GL11.glTranslatef((float)x + 0.5F, (float)y + 0.25F, (float)z+0.5f);
            GL11.glNormal3f(0.0F, 1.0F, 0.0F);
            GL11.glRotatef(-manager.playerViewY, 0.0F, 1.0F, 0.0F);
            GL11.glRotatef(manager.playerViewX, 1.0F, 0.0F, 0.0F);
            GL11.glScalef(-f1, -f1, f1);
            GL11.glDisable(GL11.GL_LIGHTING);
            GL11.glDepthMask(false);
            GL11.glDisable(GL11.GL_DEPTH_TEST);
            GL11.glEnable(GL11.GL_BLEND);
            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
            Tessellator tessellator = Tessellator.instance;
            byte b0 = 0;

            GL11.glDisable(GL11.GL_TEXTURE_2D);
            tessellator.startDrawingQuads();
            int j = fontrenderer.getStringWidth(par2Str) / 2;
            tessellator.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
            tessellator.addVertex(-j - 1, -1 + b0, 0.0D);
            tessellator.addVertex(-j - 1, 8 + b0, 0.0D);
            tessellator.addVertex(j + 1, 8 + b0, 0.0D);
            tessellator.addVertex(j + 1, -1 + b0, 0.0D);
            tessellator.draw();
            GL11.glEnable(GL11.GL_TEXTURE_2D);
            fontrenderer.drawString(par2Str, -fontrenderer.getStringWidth(par2Str) / 2, b0, 553648127);
            GL11.glEnable(GL11.GL_DEPTH_TEST);
            GL11.glDepthMask(true);
            fontrenderer.drawString(par2Str, -fontrenderer.getStringWidth(par2Str) / 2, b0, -1);
            GL11.glEnable(GL11.GL_LIGHTING);
            GL11.glDisable(GL11.GL_BLEND);
            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
            GL11.glPopMatrix();
//        }
    }

	
	@Override
	public void renderTileEntityAt(TileEntity par1TileEntity, double par2, double par4, double par6, float par8) {
		this.renderTileEntityChestAt((TileEntitySafe) par1TileEntity, par2, par4, par6, par8);
	}
}
